
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>深入探讨Android异步精髓Handler / iVAN</title>

    <meta name="description" content="深入探讨Android异步精髓Handler 探索Android软键盘的疑难杂症 深入探讨Android异步精髓Handler 详解Android主流框架不可或缺的基石 站在源码的肩膀上全解Scroller工作机制 Android多分辨率适配框架(1)- 核心基础 Android多分辨率适配框架(2)- 原理剖析 Android多分辨率适配框架(3)- 使用指南 自定义View系列教程00–推翻自己和过往,重学自定义View 自定义View系列教程01–常用工具介绍 自定义View系列教程02–onMeasure源码详尽分析 自定义View">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">深入探讨Android异步精髓Handler</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<hr>
<br /><a href="http://blog.csdn.net/lfdfhl/article/details/52415390" rel="external nofollow noreferrer">探索Android软键盘的疑难杂症</a> <br /><a href="http://blog.csdn.net/lfdfhl/article/details/53332936" rel="external nofollow noreferrer">深入探讨Android异步精髓Handler</a> <br /><a href="http://blog.csdn.net/lfdfhl/article/details/52673536" rel="external nofollow noreferrer">详解Android主流框架不可或缺的基石</a> <br /><a href="http://blog.csdn.net/lfdfhl/article/details/53143114" rel="external nofollow noreferrer">站在源码的肩膀上全解Scroller工作机制</a></p>
<hr>
<br /><a href="http://blog.csdn.net/lfdfhl/article/details/52735103" rel="external nofollow noreferrer">Android多分辨率适配框架（1）— 核心基础</a>  <br /><a href="http://blog.csdn.net/lfdfhl/article/details/52877866" rel="external nofollow noreferrer">Android多分辨率适配框架（2）— 原理剖析</a>  <br /><a href="http://blog.csdn.net/lfdfhl/article/details/53046113" rel="external nofollow noreferrer">Android多分辨率适配框架（3）— 使用指南</a></p>
<hr>
<br /><a href="http://blog.csdn.net/lfdfhl/article/details/51671038" rel="external nofollow noreferrer">自定义View系列教程00–推翻自己和过往，重学自定义View</a> <br /><a href="http://blog.csdn.net/lfdfhl/article/details/51324275" rel="external nofollow noreferrer">自定义View系列教程01–常用工具介绍</a> <br /><a href="http://blog.csdn.net/lfdfhl/article/details/51347818" rel="external nofollow noreferrer">自定义View系列教程02–onMeasure源码详尽分析</a> <br /><a href="http://blog.csdn.net/lfdfhl/article/details/51393131" rel="external nofollow noreferrer">自定义View系列教程03–onLayout源码详尽分析</a> <br /><a href="http://blog.csdn.net/lfdfhl/article/details/51435968" rel="external nofollow noreferrer">自定义View系列教程04–Draw源码分析及其实践</a> <br /><a href="http://blog.csdn.net/lfdfhl/article/details/51508727" rel="external nofollow noreferrer">自定义View系列教程05–示例分析</a> <br /><a href="http://blog.csdn.net/lfdfhl/article/details/51559847" rel="external nofollow noreferrer">自定义View系列教程06–详解View的Touch事件处理</a> <br /><a href="http://blog.csdn.net/lfdfhl/article/details/51603088" rel="external nofollow noreferrer">自定义View系列教程07–详解ViewGroup分发Touch事件</a> <br /><a href="http://blog.csdn.net/lfdfhl/article/details/51656492" rel="external nofollow noreferrer">自定义View系列教程08–滑动冲突的产生及其处理</a></p>
<hr>
<br /><a href="http://stay4it.com/course/30" rel="external nofollow noreferrer">PS：假若您觉得文章偏长，请您浏览本文对应的视频</a></p>
<hr>
<h2>前言</h2>
<p>众所周知，Android的UI是在其主线程中进行刷新的，所以Google建议开发人员切勿在主线程中进行耗时的操作否则很容易导致应用程序无响应(ANR)。鉴于此几乎接近硬性的要求，我们常把耗时的操作(比如网络请求)置于子线程中进行；但是子线程不能直接访问UI。</p>
<p>至此，这个矛盾就凸显出来了：</p>
<ul>
<li>主线程可以刷新UI，但不能执行耗时操作</li>
<li>子线程可以执行耗时操作 ，但是不能直接刷新UI</li>
</ul>
<p>嗯哼，那有没有一个东西可以调和并化解这个矛盾呢？当然是有的，Google采用Handler把主线程和子线程精巧地联系起来——子线程中进行耗时的业务逻辑，然后利用Handler通知主线程刷新UI。除此以外，还有别的方式可以实现类似的操作么？答案是肯定的，我们也可以利用AsyncTask或者IntentService进行异步的操作。这两者又是怎么做到的呢？其实，在AsyncTask和IntentService的内部亦使用了Handler实现其主要功能。抛开这两者不谈，当我们打开Android源码的时候也随处可见Handler的身影。所以，Handler是Android异步操作的核心和精髓，它在众多领域发挥着极其重要甚至是不可替代的作用。</p>
<p>在此，对Handler的工作原理和实现机制进行系统的梳理。</p>
<hr>
<h2>ThreadLocal简介及其使用</h2>
<p>对于线程Thread大家都挺熟悉的了，但是对于ThreadLocal可能就要陌生许多了。虽然我们对于它不太了解，但是它早在JDK1.2版本中就已问世并且被广泛的使用，比如Hibernate，EventBus，Handler都运用了ThreadLocal进行线程相关的操作。如果单纯地从ThreadLocal这个名字来看，它带着浓浓的“本地线程”的味道； 然而，喝一口之后才发现根本就不是这个味儿。其实，ThreadLocal并不是用来操作什么本地线程而是用于实现不同线程的数据副本。当使用ThreadLocal维护变量时，它会为每个使用该变量的线程提供独立的变量副本；每一个线程都可以独立地改变自己的副本并且不会影响其它线程所持有的对应的副本。所以，ThreadLocal的实际作用并不与它的名字所暗含的意义相吻合，或许改称为ThreadLocalVariable(线程本地变量)会更合适一些。</p>
<p>接下来，我们通过一个实例来瞅瞅ThreadLocal的使用方式</p>
<pre><code>    /**
     * 原创作者:
     * 谷哥的小弟
     *
     * 博客地址:
     * http://blog.csdn.net/lfdfhl
     */
    private void testThreadLocal(){
        mThreadLocal.set("东京热");
        new HotThread1().start();
        new HotThread2().start();
        hot3=mThreadLocal.get();
        try{
            Thread.sleep(1000*4);
            Log.i(TAG,"HotThread1获取到的变量值: "+hot1);
            Log.i(TAG,"HotThread2获取到的变量值: "+hot2);
            Log.i(TAG,"MainThread获取到的变量值: "+hot3);
        }catch (Exception e){

        }
    }

    private class HotThread1  extends Thread{
        @Override
        public void run() {
            super.run();
            mThreadLocal.set("北京热");
            hot1=mThreadLocal.get();
        }
    }

    private class HotThread2  extends Thread{
        @Override
        public void run() {
            super.run();
            mThreadLocal.set("南京热");
            hot2=mThreadLocal.get();
        }
    }</code></pre>
<p>查看输出结果：</p>
<blockquote><p>HotThread1获取到的变量值: 北京热 <br />
  HotThread2获取到的变量值: 南京热 <br />
  MainThread获取到的变量值: 东京热</p></blockquote>
<p>在这段代码中使用ThreadLocal保存String类型的数据，并且在主线程和两个子线程中为ThreadLocal设置了不同的值，然后再将这些值分别取出。结合输出日志可以发现：在不同的线程中访问了同一个ThreadLocal对象，但是通过mThreadLocal.get()得到的值却是不一样的；也就是说：它们之间没有发生相互的影响而是保持了彼此的独立。明白了ThreadLocal的这个特性之后，我们再去理解Looper的工作机制就会容易得多了。</p>
<hr>
<h2>Looper、线程、消息队列的关系</h2>
<p>Google官方建议开发人员使用Handler实现异步刷新UI，我们在平常的工作中也很好地采纳了这个提议：首先在主线程中建立Handler，然后在子线程中利用handler.sendMessage(message)发送消息至主线程，最终消息在handleMessage(Message msg) {}得到相应的处理。这个套路，大家都再熟悉不过了；现在换个角度，我们试试在子线程中建立Handler</p>
<pre><code>private class LooperThread  extends Thread{
        @Override
        public void run() {
            super.run();
            Handler handler=new Handler();
            //doing something
        }
    }</code></pre>
<p>此处的代码很简单：LooperThread继承自Thread，并且在其run( )方法中新建一个Handler。 <br />
嗯哼，再运行一下，喔哦，报错了：</p>
<blockquote><p>Can’t create handler inside thread that has not called Looper.prepare().</p></blockquote>
<p>咦，有点出师不利呢，刚开始试就出错了…….没事，生活不就是无尽的挫折和希望嘛，这点小事嘛也不算。既然是在调用Handler的构造方法时报的错那就从该构造方法的源码入手，一探究竟:</p>
<pre><code>public Handler() {
    this(null, false);
}

public Handler(Callback callback) {
    this(callback, false);
}

public Handler(Callback callback, boolean async) {
    if (FIND_POTENTIAL_LEAKS) {
        final Class&lt;? extends Handler&gt; klass = getClass();
        if ((klass.isAnonymousClass() || klass.isMemberClass() || klass.isLocalClass()) &amp;&amp;
                (klass.getModifiers() &amp; Modifier.STATIC) == 0) {
            Log.w(TAG, "The following Handler class should be static or leaks might occur");
        }
    }

    mLooper = Looper.myLooper();
    if (mLooper == null) {
        throw new RuntimeException
        ("Can't create handler inside thread that has not called Looper.prepare()");
    }
    mQueue = mLooper.mQueue;
    mCallback = callback;
    mAsynchronous = async;
}</code></pre>
<p>请注意第20行代码： <br />
如果mLooper == null那么系统就会抛出刚才的错误：Can’t create handler inside thread that has not called Looper.prepare()。这句话的意思是：如果在线程内创建handler必须调用Looper.prepare()。既然这个提示已经提示了我们该怎么做，那就加上这一行代码：</p>
<pre><code>private class LooperThread  extends Thread{
        @Override
        public void run() {
            super.run();
            Looper.prepare();
            Handler handler=new Handler();
            System.out.println("add code : Looper.prepare()");
            //doing something
        }
    }</code></pre>
<p>嘿嘿，果然不再报错了，运行一下：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjEyMDEwOTU3MzkxNDc=.jpg"></p>
<p>既然Looper.prepare()解决了这个问题，那我们就去瞅瞅在该方法中做了哪些操作：</p>
<pre><code>/**Initialize the current thread as a looper.
 * This gives you a chance to create handlers that then reference
 * this looper, before actually starting the loop. Be sure to call
 * loop() after calling this method, and end it by calling quit().
 */
public static void prepare() {
    prepare(true);
}

private static void prepare(boolean quitAllowed) {
    if (sThreadLocal.get() != null) {
        throw new RuntimeException("Only one Looper may be created per thread");
    }
    sThreadLocal.set(new Looper(quitAllowed));
}</code></pre>
<p>从这段源码及其注释文档我们可以看出：</p>
<ol>
<li>在prepare()中利用一个Looper来初始化当前线程或者说初始化一个带有Looper的线程。 <br />
请注意第14行代码，它是这段源码的核心，现对其详细分析：</p>
<blockquote><p>sThreadLocal.set(new Looper(quitAllowed));</p></blockquote>
<p>在该行代码中一共执行了两个操作</p>
<p>(1) 构造Looper</p>
<pre><code>private Looper(boolean quitAllowed) {
    mQueue = new MessageQueue(quitAllowed);
    mThread = Thread.currentThread();
}</code></pre>
<p>在Looper的构造方法中初始化了一个消息队列MessageQueue和一个线程Thread。从这可看出：一个Looper对应着一个消息队列以及当前线程。 <br />
当收到消息Message后系统会将其存入消息队列中等候处理。至于Looper，它在Android的消息机制中担负着消息轮询的职责，它会不间断地查看MessageQueue中是否有新的未处理的消息；若有则立刻处理，若无则进入阻塞。</p>
<p>(2) 将此Looper保存到sThreadLocal中。 <br />
此处的sThreadLocal是定义在Looper类中的一个ThreadLocal类型变量</p>
<blockquote><p>static final ThreadLocal&lt;Looper&gt; sThreadLocal = new ThreadLocal&lt;Looper&gt;();</p></blockquote>
<p>Looper是framework中的一个类，sThreadLocal是它的一个static final变量。当在某一个Thread中执行Looper.prepare()时系统就会将与该Thread所对应的Looper保存到sThreadLocal中。不同的线程对着不同的Looper，但它们均由系统保存在sThreadLocal中并且互不影响，相互独立；并且可以通过sThreadLocal.get()获取不同线程所对应的Looper.</li>
<li>在调用prepare()方法后需要调用loop()方法开始消息的轮询，并且在需要的时候调用quit()方法停止消息的轮询</li>
<li>假若再次执行Looper.prepare()系统发现sThreadLocal.get()的值不再为null于是抛出异常： <br />
Only one Looper may be created per thread，一个线程只能创建一个Looper！</li>
</ol>
<p>小结：</p>
<ol>
<li>一个线程对应一个Looper</li>
<li>一个Looper对应一个消息队列</li>
<li>一个线程对应一个消息队列</li>
<li>线程，Looper，消息队列三者一一对应</li>
</ol>
<p>所以，在一个子线程中使用Handler的方式应该是这样的:</p>
<pre><code>class LooperThread extends Thread {
    public Handler mHandler;
    public void run() {
        Looper.prepare();
        mHandler = new Handler() {
            public void handleMessage(Message msg) { 

            }
        };
        Looper.loop();
      }
  }</code></pre>
<p>看到这个范例，有的人可能心里就犯嘀咕了：为什么我们平常在MainActivity中使用Handler时并没有调用Looper.prepare()也没有报错呢？ <br />
这是因为UI线程是主线程，系统会自动调用Looper.prepareMainLooper()方法创建主线程的Looper和消息队列MessageQueue</p>
<hr>
<h2>Message的发送和处理过程</h2>
<p>在讨论完Looper、线程、消息队列这三者的关系之后我们再来瞅瞅Android消息机制中对于Message的发送和处理。</p>
<p>平常最常用的方式:  <br />
handler.sendMessage(message)——&gt;发送消息  <br />
handleMessage(Message msg){}——&gt;处理消息</p>
<p>先来分析消息的入队。 <br />
Handler可以通过post()、postAtTime()、postDelayed()、postAtFrontOfQueue()等方法发送消息，除了postAtFrontOfQueue()之外这几个方法均会执行到sendMessageAtTime(Message msg, long uptimeMillis)方法，源码如下：</p>
<pre><code>public boolean sendMessageAtTime(Message msg, long uptimeMillis) {
    MessageQueue queue = mQueue;
    if (queue == null) {
        RuntimeException e = new RuntimeException(
                this + " sendMessageAtTime() called with no mQueue");
        Log.w("Looper", e.getMessage(), e);
        return false;
    }
    return enqueueMessage(queue, msg, uptimeMillis);
}

public final boolean sendMessageAtFrontOfQueue(Message msg) {
    MessageQueue queue = mQueue;
    if (queue == null) {
        RuntimeException e = new RuntimeException(
                this + " sendMessageAtTime() called with no mQueue");
        Log.w("Looper", e.getMessage(), e);
        return false;
    }
    return enqueueMessage(queue, msg, 0);
}

private boolean enqueueMessage(MessageQueue queue, Message msg, long uptimeMillis) {
    msg.target = this;
    if (mAsynchronous) {
        msg.setAsynchronous(true);
    }
    return queue.enqueueMessage(msg, uptimeMillis);
}</code></pre>
<p>在这里可以看到sendMessageAtTime()内部又调用了enqueueMessage()，在该方法内的重要操作：</p>
<ul>
<li>第一步： <br />
给msg设置了target，请参见代码第25行</p>
<p>此处的this就是当前Handler对象本身。在这就指明了该msg的来源——它是由哪个Handler发出的，与此同时也指明了该msg的归宿——它该由哪个Handler处理。不难发现，哪个Handler发出了消息就由哪个Handler负责处理。</li>
<li>第二步： <br />
将消息放入消息队列中，请参见代码第29行</p>
<p>在enqueueMessage(msg,uptimeMillis)中将消息Message存放进消息队列中，距离触发时间最短的message排在队列最前面,同理距离触发时间最长的message排在队列的最尾端。若调用sendMessageAtFrontOfQueue()方法发送消息它会直接调用该enqueueMessage(msg,uptimeMillis)让消息入队只不过时间为延迟时间为0，也就是说该消息会被插入到消息队列头部优先得到执行。</p>
<p>直觉告诉我们此处的消息队列mQueue就是该线程所对应的消息队列。可是光有直觉是不够的甚至是不可靠的。我们再回过头瞅瞅Handler的构造方法，从源码中找到确切的依据</p>
<pre><code>public Handler(Callback callback, boolean async) {
    if (FIND_POTENTIAL_LEAKS) {
        final Class&lt;? extends Handler&gt; klass = getClass();
        if ((klass.isAnonymousClass() || klass.isMemberClass() || klass.isLocalClass()) &amp;&amp;
                (klass.getModifiers() &amp; Modifier.STATIC) == 0) {
            Log.w(TAG, "The following Handler class should be static or leaks might occur");
        }
    }

    mLooper = Looper.myLooper();
    if (mLooper == null) {
        throw new RuntimeException
        ("Can't create handler inside thread that has not called Looper.prepare()");
    }
    mQueue = mLooper.mQueue;
    mCallback = callback;
    mAsynchronous = async;
}</code></pre>
<p>(1) 获取Looper，请参见代码第10行 <br />
(2) 利用Looper的消息队列为mQueue赋值，请参见代码第15行 <br />
(3) 为mCallback赋值，，请参见代码第16行 <br />
(4) 为mAsynchronous赋值，，请参见代码第17行</p>
<p>嗯哼，看到了吧，这个mQueue就是从Looper中取出来的。在之前我们也详细地分析了Looper、线程、消息队列这三者的一一对应关系，所以此处的mQueue正是线程所对应的消息队列。</li>
</ul>
<p>看完了消息的入队，再来分析消息的出队。 <br />
请看Looper中的loop()方法源码：</p>
<pre><code>public static void loop() {
    final Looper me = myLooper();
    if (me == null) {
        throw new RuntimeException("No Looper; Looper.prepare() wasn't called on this thread.");
    }
    final MessageQueue queue = me.mQueue;

    // Make sure the identity of this thread is that of the local process,
    // and keep track of what that identity token actually is.
    Binder.clearCallingIdentity();
    final long ident = Binder.clearCallingIdentity();

    for (;;) {
        Message msg = queue.next(); // might block
        if (msg == null) {
            // No message indicates that the message queue is quitting.
            return;
        }

        // This must be in a local variable, in case a UI event sets the logger
        final Printer logging = me.mLogging;
        if (logging != null) {
            logging.println("&gt;&gt;&gt;&gt;&gt; Dispatching to " + msg.target + " " +
                    msg.callback + ": " + msg.what);
        }

        final long traceTag = me.mTraceTag;
        if (traceTag != 0) {
            Trace.traceBegin(traceTag, msg.target.getTraceName(msg));
        }
        try {
            msg.target.dispatchMessage(msg);
        } finally {
            if (traceTag != 0) {
                Trace.traceEnd(traceTag);
            }
        }

        if (logging != null) {
            logging.println("&lt;&lt;&lt;&lt;&lt; Finished to " + msg.target + " " + msg.callback);
        }

        // Make sure that during the course of dispatching the
        // identity of the thread wasn't corrupted.
        final long newIdent = Binder.clearCallingIdentity();
        if (ident != newIdent) {
            Log.wtf(TAG, "Thread identity changed from 0x"
                    + Long.toHexString(ident) + " to 0x"
                    + Long.toHexString(newIdent) + " while dispatching to "
                    + msg.target.getClass().getName() + " "
                    + msg.callback + " what=" + msg.what);
        }

        msg.recycleUnchecked();
    }
}</code></pre>
<p>我们发现关于消息的处理是在一个死循环中就行的，请参见代码第13-55行。也就是说在该段代码中Looper一直在轮询消息队列MessageQueue。假若消息队列中没有未处理的消息(即queue.next()==null)则其进入阻塞block状态，假若消息队列中有待处理消息(即queue.next()!=null)则利用msg.target.dispatchMessage(msg)将该消息派发至对应的Handler。</p>
<p>到了这，可能有的人会有一个疑问：系统怎么知道把消息发送给哪个Handler呢？ <br />
嘿嘿，还记不记得enqueueMessage()中系统给msg设置了target从而确定了其目标Handler么？嗯哼，所以只要通过msg.target.dispatchMessage(msg)就可以将消息派发至对应的Handler了。那在dispatchMessage()中又会对消息做哪些操作呢？我们继续跟进源码</p>
<pre><code>public void dispatchMessage(Message msg) {
    if (msg.callback != null) {
        handleCallback(msg);
    } else {
        if (mCallback != null) {
            if (mCallback.handleMessage(msg)) {
                return;
            }
        }
        handleMessage(msg);
    }
}</code></pre>
<p>哇哈，看到这，心情就舒畅多了，基本上回到了我们熟悉的地方；在此处对Message消息进行了处理，我们来瞅瞅主要的步骤</p>
<ul>
<li>第一步： <br />
处理Message的回调callback，请参见代码第3行 <br />
比如调用handler.post(Runnable runnable)时，该runnable就会被系统封装为Message的callback。 <br />
关于这点在源码中也有非常直观的体现：</p>
<pre><code>private static Message getPostMessage(Runnable r) {
   Message m = Message.obtain();
   m.callback = r;
   return m;
}</code></pre>
</li>
<li>第二步： <br />
处理Handler的回调callback，请参见代码第6行 <br />
比如执行Handler handler=Handler(Callback callback)时就会将callback赋值给mCallback，关于这点已经在介绍Handler构造方法时分析过了，不再赘述。</li>
<li>第三步： <br />
调用handleMessage()处理消息Message，请参见代码第10行 <br />
handleMessage()的源码如下：</p>
<pre><code>public void handleMessage(Message msg) {

}</code></pre>
<p>嗯哼，它是一个空的方法。所以Handler的子类需要覆写该方法，并在其中处理接收到的消息。</li>
</ul>
<hr>
<h2>梳理Handler工作机制</h2>
<p>至此，关于Handler的异步机制及其实现原理已经分析完了。在此，对其作一个全面的梳理和总结。</p>
<p>Android异步消息机制中主要涉及到:Thread、Handler、MessageQueue、Looper，在整个机制中它们扮演着不同的角色也承担着各自的不同责任。</p>
<ul>
<li>Thread</p>
<p>负责业务逻辑的实施。 <br />
线程中的操作是由各自的业务逻辑所决定的，视具体情况进行。</li>
<li>Handler
<p>负责发送消息和处理消息。 <br />
通常的做法是在主线程中建立Handler并利用它在子线程中向主线程发送消息，在主线程接收到消息后会对其进行处理</li>
<li>MessageQueue
<p>负责保存消息。 <br />
Handler发出的消息均会被保存到消息队列MessageQueue中，系统会根据Message距离触发时间的长短决定该消息在队列中位置。在队列中的消息会依次出队得到相应的处理。</li>
<li>Looper
<p>负责轮询消息队列。 <br />
Looper使用其loop()方法一直轮询消息队列，并在消息出队时将其派发至对应的Handler.</li>
</ul>
<p>为了更好地理解这几者的相互关系及其作用，请参见如下示图</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjExMjYyMzEyMDAyMTM=.jpg"></p>
<hr>
<h2>使用Handler的错误姿势及其潜在风险</h2>
<p>关于Handler的具体用法，尤其是那些常规的使用方式在此就不再一一列举了。 <br />
 我们要讨论和分析的是在开发中不恰当地使用Handler的方式及其带来的潜在风险。</p>
<p>第一个问题： <br />
利用handler.post(Runnable runnable)执行耗时操作 <br />
请看如下示例：</p>
<pre><code>/**
 * 原创作者:
 * 谷哥的小弟
 *
 * 博客地址:
 * http://blog.csdn.net/lfdfhl
 */
public class MainActivity extends AppCompatActivity {
    private TextView mTextView;
    private Handler mHandler;
    private ImageView mImageView;
    private Resources mResources;
    private static final String TAG="stay4it";
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        init();
    }
    private void init(){
        mResources=getResources();
        mHandler=new Handler();
        mTextView=(TextView) findViewById(R.id.textView);
        mImageView =(ImageView) findViewById(R.id.imageView);
        mImageView.setOnClickListener(new OnClickListenerImpl());
        long threadID=Thread.currentThread().getId();
        Log.i(TAG,"主线程的线程ID="+threadID);
    }

    private class OnClickListenerImpl implements View.OnClickListener {
        @Override
        public void onClick(View v) {
            new TestThread().start();
        }
    }

    private class TestThread extends Thread{
        @Override
        public void run() {
            super.run();
            mHandler.post(new Runnable() {
                @Override
                public void run() {
                    String text=mResources.getString(R.string.text);
                    long threadID=Thread.currentThread().getId();
                    Log.i(TAG,"在post(Runnable r)里的run()获取到线程ID="+threadID);
                    mTextView.setText(text);
                }
            });
        }
    }
}

</code></pre>
<p>运行一下，观察效果：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjExMjYyMjU2NDIzMzM=.jpg"></p>
<p>我们在开发中可能会做如上的操作：在主线程中创建Handler，然后在子线程里利用handler.post(Runnable runnable)执行某些操作甚至是耗时的操作。可是这么做合适么？我们来看看主线程的ID和在Runnable的run()方法里获取到的线程ID，输出日志如下：</p>
<blockquote><p>主线程的线程ID=1  <br />
  在post(Runnable r)里的run()获取到线程ID=1</p></blockquote>
<p>在这里我们发现在两处获得的线程ID是同一个值，也就是说Runnable的run()方法并不是在一个新线程中执行的，而是在主线程中执行的。 <br />
为什么明明把handler.post(Runnable runnable)放入到子线程中了但是Runnable的run()却在主线程中执行呢？ <br />
其实，这个问题在之前的分析中已经提到了：调用handler.post(Runnable runnable)时，该runnable会被系统封装为Message的callback。所以，handler.post(Runnable runnable)和handler.sendMessage(Message message)这两个不同的方法在本质上是相同的——Handler发送了一条消息。在该示例中handler是在主线程中创建的，所以它当然会在主线程中处理消息；如此以来该Runnable亦会在主线程中执行；所以，在Runnable的run()方法中执行耗时的操作是不可取的容易导致应用程序无响应。</p>
<p>那么，调用view.post(Runnable runnable)会在子线程中执行还是主线程中执行呢？ <br />
我们来瞅瞅它的实现：</p>
<pre><code>public boolean post(Runnable action) {
    final AttachInfo attachInfo = mAttachInfo;
    if (attachInfo != null) {
        return attachInfo.mHandler.post(action);
    }
    getRunQueue().post(action);
    return true;
}</code></pre>
<p>看到这段源码就无需再做过多的解释了，它依然是在主线程中执行的，原理同上。</p>
<p>那么，调用Activity.runOnUiThread(Runnable runnable)方法会在子线程中执行还是主线程中执行呢？</p>
<pre><code>public final void runOnUiThread(Runnable action) {
    if (Thread.currentThread() != mUiThread) {
        mHandler.post(action);
    } else {
        action.run();
    }
}</code></pre>
<p>嗯哼，这段源码就更简单了。如果当前线程是UI线程，那么该Runnable会立即执行；如果当前线程不是UI线程，则使用handler的post()方法将其放入UI线程的消息队列中。</p>
<p>小结： <br />
handler.post(Runnable runnable)、view.post(Runnable runnable)、Activity.runOnUiThread(Runnable runnable)的runnable均会在主线程中执行，所以切勿在其run()方法中执行耗时的操作</p>
<p>第二个问题： <br />
Handler导致的潜在内存泄露 <br />
请看如下示例：</p>
<pre><code>import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.support.v7.app.AppCompatActivity;
import android.util.Log;

/**
 * 原创作者:
 * 谷哥的小弟
 *
 * 博客地址:
 * http://blog.csdn.net/lfdfhl
 */
public class MainActivity extends AppCompatActivity {
    private Handler mHandler;
    private static final String TAG="stay4it";
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        init();
    }

    private void init() {
        mHandler = new Handler() {
            @Override
            public void handleMessage(Message msg) {
                super.handleMessage(msg);
                Log.i(TAG,"handle message");
            }
        };
        Message message=Message.obtain();
        message.what=9527;
        mHandler.sendMessage(message);

        mHandler.postDelayed(new Runnable() {
            @Override
            public void run() {

            }
        }, 1000 * 20);
    }
}
</code></pre>
<p>以上是我们在工作中常见的对于Handler的使用方式，为了更形象地说明问题特意把Runnable所延迟时间设置得比较久。如此操作，猛地一看觉得没啥不妥当的地方；但是简单地分析一下这段代码，却发现它存在潜在的内存泄露风险。</p>
<ul>
<li>内部类new Handler(){}持有外部类MainActivity的引用</li>
<li>内部类new Runnable(){}持有外部类MainActivity的引用</li>
<li>new Runnable(){}会被封装成Message的callback且Message会持有Handler的引用</li>
<li>handler发送了延迟消息，所以消息队列持该Runnable的引用</li>
<li>综合这几者，可理解为消息间接地持有了MainActivity的引用</li>
</ul>
<p>现在假设这么一种情况：进入该Activity后在20秒以内的任意时间旋转屏幕，此时会导致Activity重新绘制。但是通过postDelayed()发出的Runnable还未被执行，所以消息队仍列持有Runnable的引用，而Runnable也依然持有Activity的引用，故此时Activity所占内存并不能向期望的那样被回收，这样就可能会造成内存的泄漏。</p>
<p>优化该问题的方式有多种，在此展示其中一种比较好的实现方式：</p>
<pre><code>/**
 * 原创作者:
 * 谷哥的小弟
 *
 * 博客地址:
 * http://blog.csdn.net/lfdfhl
 */
public class MainActivity extends AppCompatActivity {
    private Activity mActivity;
    private static final String TAG="stay4it";
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        init();
    }

    private void init(){
        mActivity=this;
        BetterHandler betterHandler = new BetterHandler(mActivity);
        Message message=Message.obtain();
        message.what=9527;
        betterHandler.sendMessage(message);
        betterHandler.postDelayed(new BetterRunnable(), 1000 * 20);
    }

    private static class BetterRunnable implements Runnable {
        @Override
        public void run() {
            Log.i(TAG,"Runnable run()");
        }
    }

    private static class BetterHandler extends Handler {
        private WeakReference&lt;Activity&gt; activityWeakReference;

        public BetterHandler(Activity activity) {
            activityWeakReference = new WeakReference&lt;&gt;(activity);
        }

        @Override
        public void handleMessage(Message msg) {
            super.handleMessage(msg);
            if (activityWeakReference.get() != null) {
                Log.i(TAG,"handle message");
            }
        }
    }
}
</code></pre>
<p>看到这段代码，我们发现了一个陌生的东西WeakReference。什么是WeakReference呢？它有什么特点呢？</p>
<p>从JDK1.2开始，Java把对象的引用分为四种级别，这四种级别由高到低依次为：强引用、软引用、弱引用和虚引用。</p>
<ol>
<li>强引用 <br />
我们一般使用的就是强引用，垃圾回收器一般都不会对其进行回收操作。当内存空间不足时Java虚拟机宁愿抛出OutOfMemoryError错误使程序异常终止，也不会回收具有强引用的对象</li>
<li>软引用 <br />
如果一个对象具有软引用(SoftReference)，在内存空间足够的时候GC不会回收它，如果内存空间不足了GC就会回收这些对象的内存空间。</li>
<li>弱引用 <br />
如果一个对象具有弱引用(WeakReference)，那么当GC线程扫描的过程中一旦发现某个对象只具有弱引用而不存在强引用时不管当前内存空间足够与否GC都会回收它的内存。由于垃圾回收器是一个优先级较低的线程，所以不一定会很快发现那些只具有弱引用的对象。为了防止内存溢出，在处理一些占用内存大而且生命周期较长的对象时候，可以尽量使用软引用和弱引用.</li>
<li>虚引用 <br />
虚引用(PhantomReference)与其他三种引用都不同，它并不会决定对象的生命周期。如果一个对象仅持有虚引用，那么它就和没有任何引用一样，在任何时候都可能被垃圾回收器回收。所以，虚引用主要用来跟踪对象被垃圾回收器回收的活动，在一般的开发中并不会使用它</li>
</ol>
<p>嗯哼，在了解这四种引用之后我们继续分析刚才的代码。在该示例中做了如下主要操作：</p>
<ul>
<li>将Handler和Runnable定义为Activity的静态内部类</p>
<p>这两者定义为静态内部类后它们就不再持有外部类(Activity)的引用，具体代码请参见示例中BetterHandler和BetterRunnable的实现</li>
<li>在BetterHandler内使用弱引用WeakReference持有Activity
<p>在完成这两步操作之后，我们再来分析刚才的场景：进入该Activity后在20秒以内的任意时间旋转屏幕导致Activity重新绘制。此时，消息持有Handler的引用，但Handler对象不再持有Activity的强引用，所以系统可以回收该Activity从而避免了内存泄露的发生。对于这样的做法，可能有的人觉得不是特别好理解，那我再换一种直白的通俗的描述：如果直接将Activity传入BetterHandler中并且不对其使用WeakReference那么它依然是一个强引用，这和之前未优化的代码相比是没有任何差别的。假若把Activity传进BetterHandler之后并用WeakReference“包裹”了它，使之不再是一个强引用而变成了一个弱引用。当Activity发生重绘时，GC发现对于这个Activity没有强引用而只存在一个弱引用，那么系统就将其回收。</li>
<li>在handleMessage( )对Activity进行非空判断
<p>因为Activity可能已经被GC回收，所以在处理消息时要判断Activity是否为null，即if(activityWeakReference.get() != null)从而避免异常的发生。</li>
</ul>
<hr>
<h2>后语</h2>
<p>我想能看到这的人已经不多了。</p>
<p>大家都知道，Handler在Android体系中占有具有举足轻重的作用，只有掌握了Handler的实现原理和工作机制才可能更全面，更深入地掌握Android开发技能。在本文中我力图详细地阐述Handler相关技术，所以文章的篇幅偏长了。如果你耐着性子看到了此处，请为自己点个赞；你的坚持和努力不会白费，它们会让你变得更好。</p>
<hr>
<br /><a href="http://stay4it.com/course/30" rel="external nofollow noreferrer">PS：假若您觉得文章偏长，请您浏览本文对应的视频</a></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 12:22:38</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/android/" title="android">android</a>, <a href="https://www.iamivan.net/tag/%e7%ba%bf%e7%a8%8b/" title="线程">线程</a>, <a href="https://www.iamivan.net/tag/thread/" title="thread">thread</a>, <a href="https://www.iamivan.net/tag/static/" title="static">static</a>, <a href="https://www.iamivan.net/tag/%e6%ba%90%e7%a0%81/" title="源码">源码</a>, <a href="https://www.iamivan.net/tag/void/" title="void">void</a>, <a href="https://www.iamivan.net/tag/class/" title="class">class</a>, <a href="https://www.iamivan.net/tag/activity/" title="activity">activity</a>, <a href="https://www.iamivan.net/tag/handler/" title="handler">handler</a>, <a href="https://www.iamivan.net/tag/%e6%b6%88%e6%81%af%e9%98%9f%e5%88%97/" title="消息队列">消息队列</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>深入探讨Android异步精髓Handler的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pkJZroM.html" rel="bookmark">Android异步消息处理机制完全解析-Handler详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				参考资料 - 官方介绍文档 - Android 异步消息处理机制 让你深入理解 Looper.Handler.Message三者关系 - Android异步消息处理机制完全解析,带你从源码的角度彻底理解 - 慕课网课程-Android面试常客Handler详解 如果在非UI线程中更新UI会出现问题吗? 实践: public class MainActivity extends AppCompatActivity { @BindView(R.id.id_tv) TextView idTv; @Ov			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M6N3EOM.html" rel="bookmark">Android异步更新UI的四种方式&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				大家都知道由于性能要求,android要求只能在UI线程中更新UI,要想在其他线程中更新UI,大致有4种方式,下面分别使用四种方式来更新一个TextView.1.使用Handler消息传递机制 package com.example.runonuithreadtest; import android.app.Activity; import android.os.Bundle; import android.os.Handler; import android.widget.TextView;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ze65q0b.html" rel="bookmark">Android异步编程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android的线程和内存模型 Android操作系统在boot后,会启动一个Zygote(受精卵)进程,Zygote进程负责创建大部分应用程序进程.Zygote进程启动加载核心程序库和数据结构到内存后会创建一个Dalvik虚拟机(DVM)进程--SystemServer,此进程会包含大部分的系统服务(包括管理Activity的服务ActivityManagerService),SystemServer初始化后,Zygote进程会侦听本地的socket端口, 等待进一步的指令.当新的app被启动			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zGE253M.html" rel="bookmark">Android异步回调中的UI同步性问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android程序编码过程中,回调无处不在.从最常见的Activity生命周期回调开始,到BroadcastReceiver.Service以及Sqlite等.Activity.BroadcastReceiver和Service这些基本组件的回调路径和过程也就是通常意义上所谓的&quot;生命周期&quot;.同时,在处理具体的业务逻辑时,常常设计到不同线程之间的通信,如下载图片完成后通知 UI线程更新UI,凡此类场景,无论使用哪一种具体的线程间通信方式(Handler/Message.Handler/p			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0N2yjz.html" rel="bookmark">Android异步回调中的UI同步性问题分析&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android程序编码过程中,回调无处不在.从最常见的Activity生命周期回调开始,到BroadcastReceiver.Service以及Sqlite等.Activity.BroadcastReceiver和Service这些基本组件的回调路径和过程也就是通常意义上所谓的&quot;生命周期&quot;.同时,在处理具体的业务逻辑时,常常设计到不同线程之间的通信,如下载图片完成后通知 UI线程更新UI,凡此类场景,无论使用哪一种具体的线程间通信方式(Handler/Message.Handler/p			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqVoLKp.html" rel="bookmark">Android异步加载全解析之IntentService</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android异步加载全解析之IntentService 搞什么IntentService 前面我们说了那么多,异步处理都使用钦定的AsyncTask,再不济也使用的Thread,那么这个IntentService是个什么鬼. 相对与前面我们提到的这两种异步加载的方式来说,IntentService有一个最大的特点,就是--IntentService不受大部分UI生命周期的影响,它为后台线程提供了一个更直接的操作方式.不过,IntentService的不足主要体现在以下几点: 不可以直接和UI做			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zO2e1kp.html" rel="bookmark">Android异步回调中的UI同步性问题分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android程序编码过程中,回调无处不在.从最常见的Activity生命周期回调开始,到BroadcastReceiver.Service以及Sqlite等.Activity.BroadcastReceiver和Service这些基本组件的回调路径和过程也就是通常意义上所谓的&quot;生命周期&quot;.同时,在处理具体的业务逻辑时,常常设计到不同线程之间的通信,如下载图片完成后通知 UI线程更新UI,凡此类场景,无论使用哪一种具体的线程间通信方式(Handler/Message.Handler/p			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pkJrorM.html" rel="bookmark">Android异步更新UI的四种方式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				大家都知道由于性能要求,android要求只能在UI线程中更新UI,要想在其他线程中更新UI,大致有4种方式,下面分别使用四种方式来更新一个TextView. 1.使用Handler消息传递机制 package com.example.runonuithreadtest; import android.app.Activity; import android.os.Bundle; import android.os.Handler; import android.widget.TextView;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pL2kPLb.html" rel="bookmark">Android异步下载图片并且缓存图片到本地DEMO详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在Android开发中我们经常有这样的需求,从服务器上下载xml或者JSON类型的数据,其中包括一些图片资源,本demo模拟了这个需求,从网络上加载XML资源,其中包括图片,我们要做的解析XML里面的数据,并且把图片缓存到本地一个cache目录里面,并且用一个自定义的Adapter去填充到LIstView,demo运行效果见下图: 通过这个demo,要学会有一下几点 1.怎么解析一个XML 2.demo中用到的缓存图片到本地一个临时目录的思想是怎样的? 3.AsyncTask类的使用,因为要去异			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/5zOmZqM.html" rel="bookmark" class="title">Photoshop制作水波动感效果的艺术字</a>
					<div>
						  本教程主要使用Photoshop制作水波动感效果的艺术字教程,最近在被Behance和Pinterest上看到不少令人惊叹的水纹作品,使我对Photoshop的置换滤镜比较感兴趣,至今学到了一些, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9zexl0p.html" rel="bookmark" class="title">消除Google AdSense的非法广告</a>
					<div>
						我以前曾经提到过AdSense上出现腾讯QQ币骗人的广告,对于这种非法广告大家通常使用&quot;竞争性广告过滤&quot;屏蔽其域名,但是却屡禁不止,前几天我发布的&quot;国际信用卡使用的安全技 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ybjKdNM.html" rel="bookmark" class="title">完美三栏网页布局例子</a>
					<div>
						最近在内部讨论关于&quot;完美三栏&quot;的话题,看到一篇&quot;In Search of the Holy Grail&quot;,相当的好.故此翻译之. In Search of th ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Nz79AqM.html" rel="bookmark" class="title">ivy中文参考文档&lpar;12&rpar;-单独使用</a>
					<div>
						1) 单独使用 ivy可以非常容易的作为一个单独的程序使用.你所需要的只是一个java1.4+的运行环境(JRE)! 这是如何调用它的例子: java -jar ivy.jar -? 它将实现类似这样 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnx4GZb.html" rel="bookmark" class="title">stup&period;exe木马病毒的手动解决办法</a>
					<div>
						病毒文件名:stup.exe 文件路径:C:\PROGRA~1\TENCENT\Adplus\stup.exe(多数情况下) (注:有可能是SOSO的地址栏插件,如果在以上路径找到了,那就是病毒了,要 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj71wZM.html" rel="bookmark" class="title">走进Linq-Linq to SQL源代码赏析，通过Linq to SQL看Linq</a>
					<div>
						LINQ,语言集成查询,就是把一些查询操作集成到语言中(貌似是废话),比 如查询关系数据库,而且提供一种一致的操作方式,不管最终的数据存储在哪里 ?内存中,远程数据库还是一Xml格式文件存储,不仅仅如 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRyKVqb.html" rel="bookmark" class="title">用Sql server一次插入多条数据</a>
					<div>
						可以将多条数据组成一棵XML树 将XML树作为varchar参数传入 用 insert xx select xxx from openxml() 的语法插入数据 一个小例子: declare @sss ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW15Oqz.html" rel="bookmark" class="title">开源中国iOS客户端学习 &lpar;四&rpar; GCDiscreetNotificationView提示视图</a>
					<div>
						GCDiscreetNotificationView 类库作用是: 在不阻止用户与设备应用程序交互情况下,作为一个通知视图来显示一个当前的状态. GCDiscreetNotificationView  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXBXx4b.html" rel="bookmark" class="title">什么是ipv9协议&comma;ipv9协议是什么意思&quest;</a>
					<div>
						什么是ipv9协议,ipv9协议是什么意思? 根据&lt;采用全数字码给上网的计算机分配地址的方法&gt;发明专利实施并发展而成的&quot;十进制网络&quot;采用的是自主知识产权.以十进制算法( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQNRnoM.html" rel="bookmark" class="title">Win7开启AHCI提升硬盘性能 什么是硬盘的AHCI模式？</a>
					<div>
						如今的电脑系统中,硬盘的性能已经成为影响整机表现的最大瓶颈.而在对配件要求较高的Windows7系统中,硬盘自然成为了需要优化的对象,而通过开启硬盘的AHCI模式,可以在一定程度上提升硬盘的性能.那么 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOa0ykM.html" rel="bookmark" class="title">FrontPage基础教程特效按钮的制作</a>
					<div>
						  特效按钮的制作 用一般的方法制作网页中的按钮,一点也不好看,还是用个FrontPage来制作一个特效按钮吧. 1.打开FrontPage,点击菜单&quot;插入-Web组件&quot;. (图1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE6Z0PM.html" rel="bookmark" class="title">服务器-关于手机和电脑网站的问题</a>
					<div>
						问题描述 关于手机和电脑网站的问题 如果只有一台服务器,怎么实现电脑网站的数据访问和手机网站的数据访问相互独立呢(数据库是同一个数据库)?2个网站不是用一个语言写的.望大神指教指教 解决方案 不管你是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1lPOxb.html" rel="bookmark" class="title">一起爪哇Java 8（一）&mdash;&mdash;函数式接口</a>
					<div>
						标签(空格分隔): Java 引言 目前由于系统已经全面切换为JDK8,所以有必要系统的了解一下Java8的一些新特性,以便后续在日常工作中可以使用一些高级特性来提高编程效率. 因为Java8引入了函 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZEvvap.html" rel="bookmark" class="title">【整理】SecureCRT 中文显示乱码问题解决</a>
					<div>
						远程 linux 机器.修改环境变量 LANG .例如在 ~/.bash_profile 里面添加  ? 1 2 3 # User specific environment and startup p ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRqQ1eb.html" rel="bookmark" class="title">php-html 表单提交之后页面不跳转</a>
					<div>
						问题描述 html 表单提交之后页面不跳转 form标签中action属性为一个php文件,使用post方法进行参数传递,我想做到的是 表单提交之后,php接受到post的内容进行处理,html页面不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZg7YBb.html" rel="bookmark" class="title">winform操作webbrowser控件，全自动延时执行过程的精准控制！</a>
					<div>
						问题描述 winform操作webbrowser控件,全自动延时执行过程的精准控制! 如题,我有20个方法(都是操作webbrowser控件的)需要依次执行,执行第一个方法之后会返回一个结果,根据这个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWlOAmp.html" rel="bookmark" class="title">C&num;如何将一个方法公开出去，先在一个类库中声明生成dll后，在主程序中实现，求如何实现</a>
					<div>
						问题描述 C#如何将一个方法公开出去,先在一个类库中声明生成dll后,在主程序中实现,求如何实现 就是主程序的一个方法 继承类库声明的方法后 通过类库生成的dll公开出去,主程序要如何让实现类库中声明 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0ReRmz.html" rel="bookmark" class="title">盘点公有云计算应用</a>
					<div>
						1.开发与测试 第一组公有云应用就是开发与测试应用.在没有采用虚拟化时,每个应用服务器和数据库服务器都可能各自占用一台物理服务器,也就是说,服务器的使用率只有很可怜的10%.即使采用了虚拟化,服务器也 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAElaQM.html" rel="bookmark" class="title">UITableView如何撤销移动操作</a>
					<div>
						大熊猫猪·侯佩原创或翻译作品.欢迎转载,转载请注明出处. 如果觉得写的不好请多提意见,如果觉得不错请多多支持点赞.谢谢! hopy ;) 我们知道使用UITableView的委托方法canMoveRo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0n7omz.html" rel="bookmark" class="title">诚聘技术人员</a>
					<div>
						问题描述 公司名称:北京东方国通信息技术有限公司公司网址:http//www.gongqiu.com.cn招聘中级.Net开发工程师?职责:主要负责公司Winform产品的开发和维护.?薪金:(视能力 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0NDa6z.html" rel="bookmark" class="title">使用javascript获取flash加载的百分比的实现代码&lowbar;javascript技巧</a>
					<div>
						复制代码 代码如下: &lt;!DOCTYPE HTML&gt; &lt;html lang=&quot;en-US&quot;&gt; &lt;head&gt; &lt;meta charset=& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8Ny0Zb.html" rel="bookmark" class="title">visual studio 2013-由于未为 TypeScript 编译器给定要编译的文件，因此该编译器将跳过编译。</a>
					<div>
						问题描述 由于未为 TypeScript 编译器给定要编译的文件,因此该编译器将跳过编译. 使用vs2013开发跨平台应用时报错:由于未为 TypeScript 编译器给定要编译的文件,因此该编译器将 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn82yZb.html" rel="bookmark" class="title">有这样一个GIS项目，求技术架构&excl;</a>
					<div>
						问题描述 有这样一个项目,用户是一个采油厂,要求把他的上千口油井在地图上标注出来,并且根据井周边的环境.井的产量.井的类型等,对井进行不同的标识来区分.要求可编辑部分为:井的位置.周边环境(如联合站. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3Y233p.html" rel="bookmark" class="title">java编程中捕获多个异常try实例</a>
					<div>
						Java 7使得我们能够在同一个catch语句块中捕获多种不同的异常,这也叫做多重异常捕获. 在java7以前,我们可能要这样做:  代码如下 复制代码 try {     // execute co ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNm8odb.html" rel="bookmark" class="title">淘宝为商铺提供资金周转贷月息1&period;8&percnt;</a>
					<div>
						本报记者 沈衍琪 眼下正值秋冬备货高峰期,店铺开张仅一年半.信用刚刚拿下&quot;单皇冠&quot;的淘宝商户店主乐先生着了急.&quot;好几万元的资金缺口不知怎么填,难道看着人家红红火火进货.销 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk7EPyp.html" rel="bookmark" class="title">Linux修改挂载目录名称</a>
					<div>
						Local系统管理员新增了一个VG,将一个原挂载点/u02改为了/u02-old, 如下所示. [root@mylnx01 ~]# df -h Filesystem            Size   ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOW1Gxz.html" rel="bookmark" class="title">jbpm5&period;1介绍（10）</a>
					<div>
						Junit测试异常事件触发 下面的示例中测试在程序中触发异常事件的流程,流程如下 测试程序 public void testTimerBoundaryEventInterrupting() throw ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9vWYVp.html" rel="bookmark" class="title">完美实现了产品研发与需求契合的最佳经营模式，实现了双赢</a>
					<div>
						可同时检测室内的一氧化碳和甲烷,一旦发现泄露,立即报警并自动排出--近日,海尔极智倍+安全燃气热水器在北京亮相,作为业内唯一实现同时防护一氧化碳和甲烷的燃气热水器产品,其安防系统获得众多消费者的认可. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Myv1Plp.html" rel="bookmark" class="title">母婴社区的闭环之路，用电商塑造一个10亿美金公司</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 随着女性经期助手美柚完成3500万美金C轮融资.大姨妈完成3000万美金C轮融资,女性社区辣妈帮完成2000万美金的B轮融资.新的消费意识以及育儿理念普 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/baEe3nb.html" rel="bookmark" class="title">Linux命令大全磁盘管理&colon; quotaoff</a>
					<div>
						功能说明:关闭磁盘空间限制. 语 法:quotaoff&amp;http://www.aliyun.com/zixun/aggregation/37954.html&quot;&gt;nbsp;[-a ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.050 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
